#define RESIZE
#include <Xm/Xm.h>
#include <Xm/Scale.h>
#include <Xm/ToggleB.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include "paint.h"

static int res_x, res_y;
static inpNumStruct *sizeXInd, *sizeYInd;
static Boolean wait4FinalValue, widthCBRemoved, heightCBRemoved;
static int prmX, prmY;

static void keepARCB(Widget w, XtPointer clientData, XtPointer callData);

DRESIZE void resizePicture(XImage *xsi, XImage *xdi, Rectangle *src, Rectangle *dst)
{
 int dy, dx, sy;
 char *d;

 /* The algorithm for anamorphic resizing */
 for (dy = dst->y; dy < (int) (dst->height + dst->y); dy++)
  {
   sy = (int) (dy * src->height) / (int) dst->height;
   d = &xdi->data[xdi->bytes_per_line * dy + dst->x];
   for (dx = dst->x; dx < (int) (dst->width + dst->x); dx++)
    *d++ = xsi->data[xsi->bytes_per_line * sy +
     (int) (dx * src->width) / (int) dst->width];
  }
}

/*Undo scale selection area */
DRESIZE void undoScaleSelectionArea()
{
 /*refresh old background */
 drawSelectionBoundariesWrapped(drawAreaWin, 1, 1, 0, 0);
 MyPutImage(drawAreaWin, xinfo.gc, ApData.img,
  Select.x, Select.y, Select.x, Select.y, Select.width, Select.height, NULL);
 refreshZoomWin(opBounds.x, opBounds.y, opBounds.width, opBounds.height, True);
 drawSelectionBoundariesWrapped(XtWindow(zoomDrawAreaW), zoomDraw.factorX,
  zoomDraw.factorY, zoomDraw.clipWin.x, zoomDraw.clipWin.y);

 undoXImage (&Select.img);
 Select.img = Undo.img;
 Undo.imgAllocated = False;
 Select.imgAllocated = True;
 Select.width = opBounds.width = Undo.img->width;
 Select.height = opBounds.height = Undo.img->height;
 Select.x = opBounds.x = Undo.points[Undo.npoints - 2].x;
 Select.y = opBounds.y = Undo.points[Undo.npoints - 2].y;

 Select.npoints = 0;
 setBoundaryPtsR(&Select.npoints, Select.x, Select.y, Select.width, Select.height);
 Select.selected = Select.rect_on = True;
 /* first copy original part of picture to zoom pixmap */
 refreshZoomWin(opBounds.x, opBounds.y, opBounds.width, opBounds.height, True);
 LastDrawOnAllWin(False);
 disableUndo();
}

/*scales selected area to new size determined in Undo.points[newsizeP] */
DRESIZE Boolean scaleSelectionArea(int newSizePtr)
{
 int dst_x_size, dst_y_size;
 XImage *di, *si;
 Rectangle oldR, newR;

 oldR.x = oldR.y = newR.x = newR.y = 0;
 oldR.width = (unsigned int) Select.width;
 oldR.height = (unsigned int) Select.height;

 newR.width = dst_x_size = Undo.points[newSizePtr].x;
 newR.height = dst_y_size = Undo.points[newSizePtr].y;

 di = doXImage (8, dst_x_size, dst_y_size);

 if (Select.imgAllocated)
  {
   si = Select.img;
   Select.imgAllocated = False;
  }
 else
  si = MyGetImage(ApData.img, Select.x, Select.y, Select.width, Select.height, ApData.viewMode);
 if ((!checkXImage (di)) || (!checkXImage (si)))
  {
   undoXImage(&di);
   undoXImage(&si);
   disableUndo();
   return(False);
  }
 else
  {
   int size_x, size_y;

   ChangeCursor(XtWindow (mainW), XC_watch, True);
   ChangeCursor(drawAreaWin, XC_watch, True);
   if (XtIsRealized (zoomDrawAreaW))
     ChangeCursor (XtWindow (zoomDrawAreaW), XC_watch, True);

   resizePicture(si, di, &oldR, &newR);

   size_x = dst_x_size;
   size_y = dst_y_size;

   Undo.img = si;
   Undo.imgAllocated = True;
   Undo.tool = ApData.tool;

   if (Select.imgAllocated)
     undoXImage (&Select.img);
   Select.img = di;
   Select.imgAllocated = True;

   Select.x = Undo.points[newSizePtr - 1].x;
   Select.y = Undo.points[newSizePtr - 1].y;
   Select.width = size_x;
   Select.height = size_y;

   /*copy old background if new size is smaller or shifted */
   Select.npoints = 0;
   setBoundaryPtsR(&Select.npoints, Select.x, Select.y, Select.width, Select.height);

   if ((Select.width < Undo.points[newSizePtr - 2].x) ||
       (Select.height < Undo.points[newSizePtr - 2].y))
    {
     MyPutImage(drawAreaWin, xinfo.gc, ApData.img,
      Undo.points[newSizePtr - 3].x, Undo.points[newSizePtr - 3].y,
      Undo.points[newSizePtr - 3].x, Undo.points[newSizePtr - 3].y,
      Undo.points[newSizePtr - 2].x, Undo.points[newSizePtr - 2].y, NULL);
     opBounds.x = Undo.points[newSizePtr - 3].x;
     opBounds.y = Undo.points[newSizePtr - 3].y;
     opBounds.width = Undo.points[newSizePtr - 2].x;
     opBounds.height = Undo.points[newSizePtr - 2].y;
     refreshZoomWin(opBounds.x, opBounds.y, opBounds.width, opBounds.height, True);
    }
   Undo.area.x = opBounds.x = Select.x;
   Undo.area.y = opBounds.y = Select.y;
   Undo.area.width = opBounds.width = Select.width;
   Undo.area.height = opBounds.height = Select.height;
   Select.rect_on = False; /* to prevent from drawing the boundaries */
   opBounds.x -= 2;
   opBounds.y -= 2;
   opBounds.width += 4;
   opBounds.height += 4;
   if (Shm.alloc)
    XSync (xinfo.dpy, False);
   LastDrawOnAllWin (False);

   Select.selected = Select.rect_on = True;
   RestoreCursor (XtWindow (mainW));
   RestoreCursor (drawAreaWin);
   if (XtIsRealized(zoomDrawAreaW))
    RestoreCursor(XtWindow(zoomDrawAreaW));
   return (True);
  }
}
#define CHSZ_ACTIVATE 5
#define CHSZ_WIDTH_INIT 6
#define CHSZ_HEIGHT_INIT 7

/* Initialize Change Size Dialog */
DRESIZE void InitChSizeDlgCB(Widget w, XtPointer clientData, XtPointer callData)
{
 int prm = atoi ((char *) clientData);

 switch (prm)
  {
   case CHSZ_WIDTH_INIT:
    sizeXInd = initInputText (w, ApData.width, 2, maxWidth);
    break;
   case CHSZ_HEIGHT_INIT:
    sizeYInd = initInputText (w, ApData.height, 2, maxHeight);
    break;
   case CHSZ_ACTIVATE:
    finalDraw (ApData.pixy);
    disableUndo ();
    if (ApData.viewMode != normalView)
      XmToggleButtonSetState (normalViewTBW, True, True);

    setInpArrVal (sizeXInd, ApData.width);
    setInpArrVal (sizeYInd, ApData.height);
    XtManageChild (zoomDialogW);
    break;
  }
}

DRESIZE void changeSizePicture(Rectangle * oldSize, Rectangle * newSize, Boolean fit2size)
{
 XImage *img, *tmp;
 Rectangle srcR, dstR;

 img = SubImage (ApData.img, oldSize->x, oldSize->y, oldSize->width, oldSize->height);
 if (!checkXImage (img))
   return;

 /* release old image */
 freeMainImage (&ApData.img);
 tmp = createMainImage (newSize->width, newSize->height);
 if (!checkXImage (tmp))
  {
   ApData.img = createMainImage (ApData.width, ApData.height);
   if ((ApData.img == NULL) || (img == NULL))	/* fatal error */
    {
     manageErrorDialog(getTxtI8N(RESIZE_PICTURE_FATAL_ERROR_MSG),
      reallyExitCB, "1", getTxtI8N(PROGRAM_EXIT_MSG));
     return;
    }
   CopyAreaImg(img, ApData.img, NULL, 0, 0, 0, 0, img->width, img->height, 0, 0);
  }
 else /* proceed if everything was OK */
  {
   if (fit2size)
    {
     srcR.x = srcR.y = dstR.y = dstR.x = 0;
     srcR.width = oldSize->width;
     srcR.height = oldSize->height;
     dstR.width = newSize->width;
     dstR.height = newSize->height;
     resizePicture(img, tmp, &srcR, &dstR);
    }
   else /*just set new size without resizing contents */
    {
     memset(tmp->data, xinfo.allocCells[ColorMatrix.BckColorInd].pixel,
      tmp->bytes_per_line * tmp->height);
     CopyAreaImg(img, tmp, NULL, 0, 0, 0, 0, img->width, img->height, 0, 0);
    }
   ApData.img = tmp;
   repeats.width = repeats.crop.width = ApData.width = ApData.DAwidth = newSize->width;
   repeats.height = repeats.crop.height = ApData.height = ApData.DAheight = newSize->height;
   repeats.crop.x = repeats.crop.y = 0;
   XtVaSetValues(drawAreaWID, XmNheight, newSize->height, XmNwidth, newSize->width,
     XmNbackground, ApData.drawinfo.backgrndC, XmNforeground, ApData.drawinfo.foregrndC, NULL);
   getClipWinDims (clipWin, scrollBX, scrollBY, ApData.DAwidth, ApData.DAheight, &ApData.clipWin);
   refreshDrawingArea (True, True);
   zoomDraw.newImage = True;
   ApData.pic_change = True;
   zoomMapWindow();
  }
 undoXImage(&img);
}

/* maintain width/height ratio function */
static void calcAspectRatio(XtPointer clientData, XtIntervalId * id)
{
 if ((int) clientData == 1)
  {
   setInpArrVal(sizeYInd, sizeXInd->value / ApData.aspectRatio + 0.5);
   XtAddCallback(sizeYInd->inpField, XmNvalueChangedCallback,
		  (XtCallbackProc) keepARCB, (XtPointer) prmY);
   heightCBRemoved = False;
  }
 else if ((int) clientData == 2)
  {
   setInpArrVal(sizeXInd, sizeYInd->value * ApData.aspectRatio + 0.5);
   XtAddCallback(sizeXInd->inpField, XmNvalueChangedCallback,
		  (XtCallbackProc) keepARCB, (XtPointer) prmX);
   widthCBRemoved = False;
  }
 wait4FinalValue = False;
}

/* function activated by pressing arrow buttons to change width or height */
/* of the picture. It removes the other valueChange callback, */
/* calls time out function and exits */
static void keepARCB(Widget w, XtPointer clientData, XtPointer callData)
{
 if (!wait4FinalValue)
  {
   if (((int) clientData == 2) && (!widthCBRemoved))
    {
     XtRemoveCallback(sizeXInd->inpField, XmNvalueChangedCallback,
      (XtCallbackProc) keepARCB, (XtPointer) prmX);
     widthCBRemoved = True;
    }
   else if (!heightCBRemoved)
    {
     XtRemoveCallback(sizeYInd->inpField, XmNvalueChangedCallback,
      (XtCallbackProc) keepARCB, (XtPointer) prmY);
     heightCBRemoved = True;
    }
    XtAddTimeOut (500, (XtTimerCallbackProc) * calcAspectRatio, clientData);
    wait4FinalValue = True;
  }
}

#define CS_INIT_TB 1
#define CS_DECREASE 2
#define CS_OK 3
#define CS_OK_NEW_PICTURE 4
#define CS_TOGGLE_AR 6
#define CS_MAP 9
/* Change size of picture */
DRESIZE void ChSizePicCB(Widget w, XtPointer clientData, XtPointer callData)
{
 Rectangle rectOld, rectNew;
 Boolean fit2size = False;
 static Widget fit2sizeTB;
 int prm = atoi ((char *) clientData);

 rectNew.x = rectNew.y = rectNew.width = rectNew.height = 0;
 rectOld.x = rectOld.y = 0;
 rectOld.width = (unsigned int) ApData.width;
 rectOld.height = (unsigned int) ApData.height;

 switch (prm)
  {
   case CS_DECREASE:
     finalDraw(ApData.pixy);
     disableUndo();
     if (!Select.selected)
       manageErrorDialog(getTxtI8N (NO_SELECTION_MADE_MSG), NULL, NULL, getTxtI8N (OK_MSG));
     else
      {
       highlightButton(NULL);
       rectNew.x = Select.x;
       rectNew.y = Select.y;
       rectNew.width = (unsigned int) Select.width;
       rectNew.height = (unsigned int) Select.height;
       memcpy (&rectOld, &rectNew, sizeof (Rectangle));
       Select.rect_on = Select.selected = False;
       Select.x = Select.y = Select.npoints = Select.points[0].x = Select.points[0].y = 0;
       changeSizePicture(&rectOld, &rectNew, False);
       disableSelection(TRUE);
       ApData.tool = none;
       setToolEventHandler(ApData.tool, 0);
       changeTitleCB(NULL, ApData.fname, NULL);
      }
     break;
   case CS_OK:	/* OK button was pressed */
     highlightButton (NULL);
     ChangeCursor (XtWindow (zoomDialogW), XC_watch, True);
     ChangeCursor (XtWindow (mainW), XC_watch, True);
     ChangeCursor (drawAreaWin, XC_watch, True);
     if (XtIsRealized (zoomDrawAreaW))
       ChangeCursor(XtWindow(zoomDrawAreaW), XC_watch, True);

     XtVaGetValues (fit2sizeTB, XmNset, &fit2size, NULL);
     res_x = sizeXInd->value;
     res_y = sizeYInd->value;
     rectNew.height = (unsigned short) res_y;
     rectNew.width = (unsigned short) res_x;
     changeSizePicture (&rectOld, &rectNew, fit2size);
     RestoreCursor (XtWindow (zoomDialogW));
     RestoreCursor (XtWindow (mainW));
     RestoreCursor (drawAreaWin);
     if (XtIsRealized (zoomDrawAreaW))
       RestoreCursor (XtWindow (zoomDrawAreaW));
     XtUnmanageChild (zoomDialogW);
     zoomDraw.newImage = True;
     ApData.aspectRatio = (float) (1.0 * ApData.width) / ApData.height;
     changeTitleCB (NULL, ApData.fname, NULL);
     zoomMapWindow();
     repeats.currNum = repeats.num = 1;
     break;
   case CS_OK_NEW_PICTURE:
    {
     XPoint xp;

     XtUnmanageChild (zoomDialogW);
     XtVaSetValues (fit2sizeTB, XmNsensitive, True, NULL);
     highlightButton (NULL);
     xp.x = sizeXInd->value;
     xp.y = sizeYInd->value;
     NewFileCB (NULL, "2", (XtPointer) &xp);
    }
    break;
   case CS_TOGGLE_AR:
    {
     XmToggleButtonCallbackStruct *TBS = (XmToggleButtonCallbackStruct *) callData;

     wait4FinalValue = False;
     if (TBS->set == True)
      {
       XtAddCallback(sizeXInd->inpField, XmNvalueChangedCallback, (XtCallbackProc) keepARCB, (XtPointer) prmX);
       XtAddCallback(sizeYInd->inpField, XmNvalueChangedCallback, (XtCallbackProc) keepARCB, (XtPointer) prmY);
       heightCBRemoved = widthCBRemoved = False;
      }
     else
      {
       XtRemoveCallback(sizeXInd->inpField, XmNvalueChangedCallback, (XtCallbackProc) keepARCB, (XtPointer) prmX);
       XtRemoveCallback(sizeYInd->inpField, XmNvalueChangedCallback, (XtCallbackProc) keepARCB, (XtPointer) prmY);
       heightCBRemoved = widthCBRemoved = True;
      }
    }
    break;
   case CS_MAP:
    ApData.aspectRatio = (1.0 * ApData.width) / ApData.height;
    prmX = 1;
    prmY = 2;
    break;
   case CS_INIT_TB:
    fit2sizeTB = w;
    break;
  }
}

/* calculate index in a 3angular matrix whithout diagonal elements */
static int calcInd(int i, int j, int size3m)
{
 int tmp = 0, size = size3m - 1, k;

 if (j < i)
  SWAP (j, i);
 for (k = 0; k < i; k++)
  tmp += size--;
 tmp += j - i - 1;
 return(tmp);
}

/* get the next candidate (with smallest minimum) from the array and set its value to fillV */
static int getNextBestMin(int *arr, int arrSize, int *diffArr, int diffArrSize)
{
 int min, ind = -1, i;

 min = diffArrSize;
 for (i = 0; i < arrSize; i++)
  if (arr[i] > -1)
   if (diffArr[arr[i] - 1] < min)
    {
     min = diffArr[arr[i] - 1];
     ind = i;
    }
 if (ind > -1)
  {
   min = arr[ind];
   arr[ind] = -1;
  }
 return(min);
}

/* compare two rows or columns and store result in a triangular matrix */
static Boolean compareRowCols(int cl1, int cl2, int start, int stepNo, XImage * img,
int *mtrx, int mtrxEl, int treshold, Boolean horizontal)
{
 int i, diff = 0, ind = 0;

 ind = calcInd (cl1, cl2, mtrxEl);

 if ((mtrx != NULL) && (mtrx[ind] > -1))
  {
   if (mtrx[ind] < treshold)
    return(True);
   else
    return(False);
  }
 if (horizontal)
  {
   for (i = start; i < start + stepNo; i++)
    if (img->data[img->bytes_per_line * i + cl1] != img->data[img->bytes_per_line * i + cl2])
     diff++;
  }
 else
  for (i = start; i < start + stepNo; i++)
   if (img->data[img->bytes_per_line * cl1 + i] != img->data[img->bytes_per_line * cl2 + i])
    diff++;

 if (mtrx != NULL)
   mtrx[ind] = diff;

 if (diff < treshold)
   return (True);
 else
   return (False);
}

/* find repeat in one dimension */
static int getRepeatXY(XImage * img, int compElements, int startElement,
 int startCompElm, int compNo, Boolean rows, int *cSet)
{
 int mtrxSize, *mtrx = NULL, *candidates = NULL;
 int candidNo = 0, i, j, c = startElement;
 Boolean found = False;

 mtrxSize = ((compElements - 1) * compElements) / 2;
 mtrx = (int *) calloc (mtrxSize, sizeof (int));

 candidates = (int *) calloc (compElements, sizeof (int));

 if (!candidates)
  { free ((char *) mtrx); return (-1); }

 if (mtrx != NULL)
   for (i = 0; i < mtrxSize; i++)
     mtrx[i] = -1;

 for (i = 1; i < compElements; i++)
  if (compareRowCols(startElement, startElement + i, startCompElm, compNo,
   img, mtrx, compElements, compNo / 5, rows))
   candidates[candidNo++] = i;

 j = 0;
 while (!found && (j < candidNo))
  {
   int repNo, k, margin;

   c = candidates[j];
   if (mtrx != NULL)
     c = getNextBestMin(candidates, candidNo, mtrx, compElements);

   repNo = compElements / c;
   for (k = 0; k < repNo; k++)
     {
      i = startElement;
      margin = (c - startElement) * (k + 1);
      while ((i < c) && ((margin + i) < compElements))
       {
	if (!compareRowCols (i, margin + i, startCompElm,
	 compNo, img, mtrx, compElements, compNo / 5, rows))
	 break;
	i++;
       }

      if ((margin + i) == compElements)
       { found = True; k = repNo; }
      else if (i != c)
       k = repNo;
     }
   j++;
  }
 free ((char *) candidates);
 free ((char *) mtrx);
 *cSet = c;
 if (found)
   return(1);
 else
   return(0);
}

static void doFindRepeat(XtPointer clientData)
{
 int r, c, width, height, x, y, res;
 XImage *img;
 Boolean found = False;

 if ((Select.selected) && (Select.rect_on))
   disableSelection(True);
 else
  {
   Select.x = Select.y = 0;
   Select.width = ApData.width;
   Select.height = ApData.height;
   Select.selected = Select.rect_on = True;
  }
 Select.rectangular = True;

 img = ApData.img;
 x = Select.x;
 width = Select.width;

 res = getRepeatXY(img, Select.width, Select.x, Select.y, Select.height, True, &c);

 if (res == -1)
  {
   manageErrorDialog(getTxtI8N(NOT_ENOUGH_MEMORY_MSG), NULL, NULL, getTxtI8N(OK_MSG));
   RestoreCursor(XtWindow (mainW));
   RestoreCursor(drawAreaWin);
   if (XtIsRealized(zoomDrawAreaW))
     RestoreCursor(XtWindow(zoomDrawAreaW));
   return;
  }
 found = res == 1;
 if (found)
   width = c - Select.x;
 Select.width = width;

 y = Select.y;
 height = Select.height;

 res = getRepeatXY(img, Select.height, Select.y, Select.x, Select.width, False, &r);
 if (res == -1)
  {
   manageErrorDialog(getTxtI8N(NOT_ENOUGH_MEMORY_MSG), NULL, NULL, getTxtI8N(OK_MSG));
   RestoreCursor(XtWindow (mainW));
   RestoreCursor(drawAreaWin);
   if (XtIsRealized(zoomDrawAreaW))
     RestoreCursor(XtWindow(zoomDrawAreaW));
   return;
  }
 found = res == 1;

 if (found)
   height = r - Select.y;

 ApData.tool = Undo.tool = selectA;

 Select.npoints = 0;
 if (height && width)
  {
   Select.x = x;
   Select.y = y;
   Select.width = width;
   Select.height = height;
  }
 setBoundaryPtsR(&Select.npoints, Select.x, Select.y, Select.width, Select.height);

 drawSelectionBoundariesWrapped(drawAreaWin, 1, 1, 0, 0);
 drawSelectionBoundariesWrapped(XtWindow (zoomDrawAreaW),
  zoomDraw.factorX, zoomDraw.factorY, zoomDraw.clipWin.x, zoomDraw.clipWin.y);

 Select.selected = Select.rect_on = True;
 RestoreCursor(XtWindow (mainW));

 XtVaSetValues(CopyBW, XmNsensitive, True, NULL);
 XtVaSetValues(CutBW, XmNsensitive, True, NULL);
 enableUndo(False);
 setToolEventHandler(pasteA, 0);
}

/* get pattern repeat */
DRESIZE void getRepeatPatternCB(Widget w, XtPointer clientData, XtPointer callData)
{
 if (ApData.viewMode != normalView)
  { XBell(xinfo.dpy, 0); return; }
 finalDraw (ApData.pixy);
 disableUndo();

 setToolEventHandler(none, XC_watch);
 highlightButton(NULL);
 ChangeCursor(XtWindow (mainW), XC_watch, True);

 ApData.tool = none;
 XtAddTimeOut(300, (XtTimerCallbackProc) *doFindRepeat, NULL);
}
