/* lpbm.c load pbm plus coded images */
#include "loadimg.h"
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <ctype.h>

static FILE *fp;
static int srcbpl;

extern void registerLoader(tryLoadProc tLoad, loadBandProc lBand, endLoadProc eLoad);

static int tryLoad(char *filename, int *loadType, int *xpixels,
 int *ypixels, int *xdpi, int *ydpi, unsigned char *cmap, char *info,
 char *reverse, int *numInterlace, int realLoad)
{
 char dummy[300];
 int i, range;
 char ptype;

 if ((fp = fopen(filename, "r" )) == NULL)
  return(LOAD_IO_ERROR);

 fgets(dummy, 300, fp);
 dummy[299]=0;
 ptype = dummy[1];
 if ((dummy[0]!='P')||(!(isdigit(ptype)))||(strlen(dummy)!=3))
  { fclose(fp); return(LOAD_FILETYPE_UNKNOWN); }

 if ((ptype!='4')&&(ptype!='5')&&(ptype!='6'))
  { fclose(fp); return(LOAD_FILETYPE_UNKNOWN); }
 fgets(dummy, 300, fp);
 dummy[299]=0;
 sprintf(info, "Pbm Plus type P%c\n%s", ptype, ((dummy[0]=='#') ? &dummy[1]:""));
 while ((dummy[0]=='#'))
  fgets(dummy, 300, fp);
 dummy[299]=0;

 sscanf(dummy, "%d %d\n", xpixels, ypixels);
 if ((*xpixels<0)||(*ypixels<0)||(*xpixels>20000)||(*ypixels>20000))
  { fclose(fp); return(LOAD_FILE_CORRUPT); }

 if (ptype=='4')
  {
   srcbpl = (*xpixels+7)/8;
   *loadType = LOAD_BW;
  }
 if (ptype=='5')
  {
   fgets(dummy, 300, fp);
   dummy[299]=0;
   sscanf(dummy, "%d\n", &range);
   if ((range<2)||(range>255))
    { fclose(fp); return(LOAD_FILE_CORRUPT); }

   for (i=0; i<=range; i++)
    cmap[i*3]=cmap[i*3+1]=cmap[i*3+2]=(i*range)/255;
   srcbpl = *xpixels;
   *loadType = LOAD_CMAP;
  }
 if (ptype=='6')
  {
   fgets(dummy, 300, fp);
   dummy[299]=0;
   sscanf(dummy, "%d\n", &range);
   if (range!=255)
    { fclose(fp); return(LOAD_FILE_CORRUPT); }
   srcbpl = *xpixels*3;
   *loadType = LOAD_TRUE_COL;
  }

 *xdpi = *ydpi = 0;
 *reverse = FALSE;
 *numInterlace = 1; /* no interlace */
 return(LOAD_OK);
}

/* loader reads a band */
static int loadBand(unsigned char *data, int  lines, int  bpl)
{
 int i;

 for (i=0; i<lines; i++)
  if (srcbpl!=fread(&data[i*bpl], 1, srcbpl, fp))
   return(LOAD_FILE_CORRUPT);

 return(LOAD_OK);
}

/* closes the input file and releases any temporary storage */
static int endLoad()
{
 fclose(fp);
 return(LOAD_OK);
}

/* register pbm plus image loader */
void registerLoadPBM()
{
 registerLoader(*tryLoad, *loadBand, *endLoad);
}
